﻿/**
* 2次元ベジェ曲線分割
* test 1
* @author nutsu
*/

package {
	
	import flash.display.Sprite;
	import flash.display.Shape;
	import flash.display.Graphics;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.utils.getTimer;
	
	public class BezjeSegmentTest1 extends Sprite{
		
		//始点
		protected var handle_start:Sprite;
		//終点
		protected var handle_end:Sprite;
		//コントロール点
		protected var handle_ctrl:Sprite;
		
		//分割点
		protected var plots:Shape;
		
		
		//編集中か
		private var now_editting:Boolean = false;
		private var edit_handle:Sprite;
		
		/**
		* コンストラクタ
		*/
		public function BezjeSegmentTest1(){
			super();
			
			//表示要素初期化
			handle_start = makeHandle();
			handle_end   = makeHandle();
			handle_ctrl  = makeHandle();
			
			plots        = new Shape();
			
			addChild( handle_start );
			addChild( handle_end );
			addChild( handle_ctrl );
			addChild( plots );
			
			//初期位置
			handle_start.x = 75;
			handle_start.y = 150;
			handle_end.x = 350;
			handle_end.y = 150;
			handle_ctrl.x = 212;
			handle_ctrl.y = 50;
			
			draw();
			
			stage.addEventListener( MouseEvent.MOUSE_UP, stopEdit );
			stage.addEventListener( MouseEvent.MOUSE_MOVE, update );
			
		}
		
		/**
		*	描画
		*/
		protected function draw():void{
			
			drawCurve();
			
			var tmp:int = getTimer();
			//-------------------------------
			
			//t等分で分割
			
			var bezje:Bezje2D = new Bezje2D( new Point(handle_start.x, handle_start.y),
			                                 new Point(handle_end.x, handle_end.y),
			                                 new Point(handle_ctrl.x, handle_ctrl.y));
			
			//分割差分
			var d:Number = 0.1;
			
			plots.graphics.clear();
			for( var t:Number=0; t<=1.0 ; t+=d ){
				plot( plots.graphics, bezje.f(t) );
			}
			//--------------------------------
			trace( "time", getTimer()-tmp );
		}
		
		protected function drawCurve():void{
			graphics.clear();
			
			//補助線
			graphics.lineStyle( 0, 0x666666 );
			graphics.moveTo( handle_start.x, handle_start.y );
			graphics.lineTo( handle_ctrl.x, handle_ctrl.y );
			graphics.lineTo( handle_end.x, handle_end.y );
			
			//2次元ベジェ
			graphics.lineStyle( 0, 0xffffff );
			graphics.moveTo( handle_start.x, handle_start.y );
			graphics.curveTo( handle_ctrl.x, handle_ctrl.y, handle_end.x, handle_end.y );
		}
		
		/**
		* リスナ
		*/
		private function startEdit( e:MouseEvent ):void{
			now_editting = true;
			edit_handle = (e.target as Sprite);
			edit_handle.startDrag(false, new Rectangle(0,0,stage.stageWidth,stage.stageHeight));
		}
		
		private function stopEdit( e:MouseEvent ):void{
			if( edit_handle!=null ){
				edit_handle.stopDrag();
			}
			now_editting = false;
			draw();
		}
		
		private function update( e:MouseEvent ):void{
			if( now_editting ) draw();
		}
		
		/**
		* ハンドル生成
		*/
		private function makeHandle():Sprite{
			var s:Sprite;
			(s = new Sprite()).addChild( makePointShape( 0xffffff, 4 ) );
			s.addEventListener( MouseEvent.MOUSE_DOWN, startEdit );
			s.buttonMode = true;
			return s;
		}
		
		/**
		* ポイント用Shape
		*/
		private function makePointShape(col:uint, size:Number):Shape{
			var d:Shape = new Shape();
			d.graphics.clear();
			d.graphics.beginFill( col );
			d.graphics.drawCircle( 0, 0, size );
			d.graphics.endFill();
			return d;
		}
		
		/**
		* プロット
		*/
		protected function plot(g:Graphics,p:Point):void{
			g.beginFill( 0xffffff );
			g.drawCircle( p.x, p.y, 2 );
			g.endFill();
		}
	}
	
}

