﻿/**
* 2次元ベジェ曲線分割 破線
* test 3
* @author nutsu
*/

package {
	
	import flash.display.Graphics;
	import flash.geom.Point;
	import flash.utils.getTimer;
	
	public class BezjeSegmentTest4 extends BezjeSegmentTest1{
		
		/**
		* コンストラクタ
		*/
		public function BezjeSegmentTest4(){
			super();
		}
		
		/**
		*	描画
		*/
		protected override function draw():void{
			
			graphics.clear();
			
			//補助線
			graphics.lineStyle( 0, 0x333333 );
			graphics.moveTo( handle_start.x, handle_start.y );
			graphics.lineTo( handle_ctrl.x, handle_ctrl.y );
			graphics.lineTo( handle_end.x, handle_end.y );
			
			//2次元ベジェ
			
			graphics.lineStyle( 0, 0x333333 );
			graphics.moveTo( handle_start.x, handle_start.y );
			graphics.curveTo( handle_ctrl.x, handle_ctrl.y, handle_end.x, handle_end.y );
			
			
			var tmp:int = getTimer();
			//-------------------------------
			//ベジェ曲線を分割して破線描画
			
			var bezje:Bezje2D = new Bezje2D( new Point(handle_start.x, handle_start.y),
			                                 new Point(handle_end.x, handle_end.y),
			                                 new Point(handle_ctrl.x, handle_ctrl.y));
			
			//破線長
			var ds:Number = 10;
			
			//分割数
			var sn:Number = bezje.length/ds;
			
			//率
			var kd:Number = 1.0/sn;
			
			graphics.lineStyle(3,0xffffff,1.0,false,"normal","none");
			for( var k:Number=0; k<1.0 ; k+=kd*2 ){
				//線分始点位置
				var len0:Number = bezje.length*k;
				//線分終点位置
				var len1:Number = bezje.length*Math.min( k+kd, 1.0 );
				
				//差が閾値以下は描画なし
				if( len1-len0>=1.0 ){
					var t0:Number = bezje.length2T( len0, 0.1 );
					var t1:Number = bezje.length2T( len1, 0.1 );
					
					//両端の座標とベクトル
					var pv0:Point = bezje.diff(t0);
					var pp0:Point = bezje.f(t0);
					var pv1:Point = bezje.diff(t1);
					var pp1:Point = bezje.f(t1);
					
					//両端の差分
					var dx:Number = pp1.x-pp0.x;
					var dy:Number = pp1.y-pp0.y;
					
					// Point(dx,dy) = a*(pv0 + pv1) のaを求める
					var a:Number;
					if( dx != 0 ){
						a = dx/(pv1.x+pv0.x);
					}else{
						a = dy/(pv1.y+pv0.y);
					}
					
					//線分描画
					graphics.moveTo( pp0.x, pp0.y );
					graphics.curveTo( pp0.x + a*pv0.x, pp0.y + a*pv0.y, pp1.x, pp1.y );
				}
			}
			//--------------------------------
			trace( "time", getTimer()-tmp );
		}
	}
	
}

